---
title: paint-order
slug: Web/SVG/Attribute/paint-order
tags:
  - SVG
  - SVG Attribute
---
<div>{{SVGRef}}</div>

<p>The <strong><code>paint-order</code></strong> attribute specifies the order that the fill, stroke, and markers of a given shape or text element are painted.</p>

<p class="note"><strong>Note:</strong> As a presentation attribute, <code>paint-order</code> can be used as a CSS property.</p>

<p>As a presentation attribute, it can be applied to any element but it has effect only on the following ten elements: {{SVGElement("circle")}}, {{SVGElement("ellipse")}}, {{SVGElement("line")}}, {{SVGElement("path")}}, {{SVGElement("polygon")}}, {{SVGElement("polyline")}}, {{SVGElement("rect")}}, {{SVGElement("text")}}, {{SVGElement("textPath")}}, and {{SVGElement("tspan")}}</p>

<h2 id="Usage_notes">Usage notes</h2>

<table class="properties">
 <tbody>
  <tr>
   <th>Value</th>
   <td><code>normal</code> | [ <code>fill</code> || <code>stroke</code> || <code>markers</code> ]</td>
  </tr>
  <tr>
   <th>Default value</th>
   <td><code>normal</code></td>
  </tr>
  <tr>
   <th>Animatable</th>
   <td>discrete</td>
  </tr>
 </tbody>
</table>

<dl>
 <dt>normal</dt>
 <dd>This value indicates that the fill will be painted first, then the stroke, and finally the markers.</dd>
 <dt>[ fill || stroke || markers ]</dt>
 <dd>The order of these three keywords indicates the order in which the painting happens, from left to right. If any of the three painting components is omitted, they will be painted in their default order after the specified components. For example, using <code>stroke</code> is equivalent to <code>stroke fill markers</code>.</dd>
</dl>

<h2 id="Example">Example</h2>

<pre class="brush: html notranslate">&lt;svg xmlns="http://www.w3.org/2000/svg" width="400" height="200"&gt;
  &lt;linearGradient id="g" x1="0" y1="0" x2="0" y2="1"&gt;
    &lt;stop stop-color="#888"/&gt;
    &lt;stop stop-color="#ccc" offset="1"/&gt;
  &lt;/linearGradient&gt;
  &lt;rect width="400" height="200" fill="url(#g)"/&gt;
  &lt;g fill="crimson" stroke="white" stroke-width="6" stroke-linejoin="round"
     text-anchor="middle" font-family="sans-serif" font-size="50px" font-weight="bold"&gt;
    &lt;text x="200" y="75"&gt;stroke over&lt;/text&gt;
    &lt;text x="200" y="150" paint-order="stroke" id="stroke-under"&gt;stroke under&lt;/text&gt;
  &lt;/g&gt;
&lt;/svg&gt;</pre>

<p>The example would be rendered as follows:</p>

<p><img alt="An image showing how the paint-order example looks in a UA that supports the paint-order property." src="/files/4567/paint-order-2.png" style="height: 200px; width: 400px;"></p>

<p>The stroke under effect could be achieved via the following CSS property:</p>

<pre class="brush: css notranslate">#stroke-under {
  paint-order: stroke;
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("SVG2", "painting.html#PaintOrderProperty", "paint-order")}}</td>
   <td>{{Spec2("SVG2")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("svg.attributes.paint-order")}}</p>
